<?php
// $Id: shipping.admin.inc,v 1.1.2.2 2008/01/08 05:09:38 brmassa Exp $
/**
 * @file shipping.admin.inc
 * All shipping admin functions
 */

/**
 * Build a table listing all configured fulfillment centers.
 */
function __shipping_fulfillmentcenter_list() {
  // The table header
  $header = array(
    array('data' => t('Name'), 'field' => 'title', 'sort' => 'asc'),
    array('data' => t('Code'), 'field' => 'code'),
    array('data' => t('City'), 'field' => 'city'),
    array('data' => t('Region'), 'field' => 'region'),
    array('data' => t('Country'), 'field' => 'country'),
    array('data' => t('Default'), 'field' => 'status'),
    array('data' => t('Operations'))
  );

  // Get all contries and states' list with names and codes
  include_once drupal_get_path('module', 'store') .'/store.localization.inc';
  $countries = _store_location_countries();
  $states = _store_location_states();

  // Look for all fulfillment centers
  $result = pager_query('SELECT * FROM {ec_shipping_fcenter}'. tablesort_sql($header), 25);

  // Generate the list
  $list = array();
  while ($fcenter = db_fetch_object($result)) {
    // If the state name is listed on $state, used it
    $state = empty($states[$fcenter->country][$fcenter->region]) ? $fcenter->region :
      $states[$fcenter->country][$fcenter->region];

    $list[] = array(
      'title'       => empty($fcenter->title) ? '' : htmlspecialchars($fcenter->title),
      'code'        => empty($fcenter->code) ? '' : $fcenter->code,
      'city'        => empty($fcenter->city) ? '' : $fcenter->city,
      'region'      => empty($fcenter->region) ? '' : $state,
      'country'     => empty($fcenter->country) ? '' : $countries[$fcenter->country],
      'status'      => empty($fcenter->status) ? '' : t('Default'),
      'operations'  => l(t('Edit'), "admin/ecsettings/fulfillment-centers/edit/$fcenter->sid") .' '.
        l(t('Delete'), "admin/ecsettings/fulfillment-centers/delete/$fcenter->sid")
    );
  }

  return theme('shipping_fulfillmentcenter_list', $list, $header);
}

/**
 * Theme the table of fulfillment centers.
 * @ingroup themeable
 */
function theme_shipping_fulfillmentcenter_list($list, $header) {
  if (!empty($list)) {
    while (list($key) = each($list)) {
      $rows[] = array(
        $list[$key]['title'], $list[$key]['code'], $list[$key]['city'],
        $list[$key]['region'], $list[$key]['country'], $list[$key]['status'],
        $list[$key]['operations']
      );
    }
    $output = theme('pager', null, 25);
    $output .= theme('table', $header, $rows);
  }
  else {
    $output = t('There are no fulfillment centers configured.');
  }
  return $output;
}

